18791: make the test hasher workflow work by fixing dns resolution
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
17
18 usage() {
19   echo >&2
20   echo >&2 "Usage: ${0} [-h] [-h]"
21   echo >&2
22   echo >&2 "${0} options:"
23   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
24   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
25   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
26   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
27   echo >&2 "                                              Possible values are:"
28   echo >&2 "                                                api"
29   echo >&2 "                                                controller"
30   echo >&2 "                                                dispatcher"
31   echo >&2 "                                                keepproxy"
32   echo >&2 "                                                keepstore"
33   echo >&2 "                                                keepweb"
34   echo >&2 "                                                shell"
35   echo >&2 "                                                webshell"
36   echo >&2 "                                                websocket"
37   echo >&2 "                                                workbench"
38   echo >&2 "                                                workbench2"
39   echo >&2 "                                              Defaults to applying them all"
40   echo >&2 "  -h, --help                                  Display this help and exit"
41   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
42   echo >&2 "                                              This parameter does not perform any installation at all. It's"
43   echo >&2 "                                              intended to give you a parsed sot of configuration files so"
44   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
45   echo >&2 "                                              It"
46   echo >&2 "                                                - parses the pillar and states templates,"
47   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
48   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
49   echo >&2 "                                                  for the selected role/s"
50   echo >&2 "                                                - writes the resulting files into <dest_dir>"
51   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
52   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
53   echo >&2
54 }
55
56 arguments() {
57   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
58   if ! which getopt > /dev/null; then
59     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
60     exit 1
61   fi
62
63   TEMP=$(getopt -o c:dhp:r:tv \
64     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
65     -n "${0}" -- "${@}")
66
67   if [ ${?} != 0 ];
68     then echo "Please check the parameters you entered and re-run again"
69     exit 1
70   fi
71   # Note the quotes around `$TEMP': they are essential!
72   eval set -- "$TEMP"
73
74   while [ ${#} -ge 1 ]; do
75     case ${1} in
76       -c | --config)
77         CONFIG_FILE=${2}
78         shift 2
79         ;;
80       -d | --debug)
81         LOG_LEVEL="debug"
82         shift
83         set -x
84         ;;
85       --dump-config)
86         if [[ ${2} = /* ]]; then
87           DUMP_SALT_CONFIG_DIR=${2}
88         else
89           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
90         fi
91         ## states
92         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
93         ## formulas
94         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
95         ## pillars
96         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
97         ## tests
98         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
99         DUMP_CONFIG="yes"
100         shift 2
101         ;;
102       --development)
103         DEV_MODE="yes"
104         shift 1
105         ;;
106       -r | --roles)
107         for i in ${2//,/ }
108           do
109             # Verify the role exists
110             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
111               echo "The role '${i}' is not a valid role"
112               usage
113               exit 1
114             fi
115             ROLES="${ROLES} ${i}"
116           done
117           shift 2
118         ;;
119       -t | --test)
120         TEST="yes"
121         shift
122         ;;
123       -v | --vagrant)
124         VAGRANT="yes"
125         shift
126         ;;
127       --)
128         shift
129         break
130         ;;
131       *)
132         usage
133         exit 1
134         ;;
135     esac
136   done
137 }
138
139 copy_custom_cert() {
140   cert_dir=${1}
141   cert_name=${2}
142
143   mkdir -p /srv/salt/certs
144
145   if [ -f ${cert_dir}/${cert_name}.crt ]; then
146     cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
147   else
148     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
149     exit 1
150   fi
151   if [ -f ${cert_dir}/${cert_name}.key ]; then
152     cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
153   else
154     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
155     exit 1
156   fi
157 }
158
159 DEV_MODE="no"
160 CONFIG_FILE="${SCRIPT_DIR}/local.params"
161 CONFIG_DIR="local_config_dir"
162 DUMP_CONFIG="no"
163 LOG_LEVEL="info"
164 CONTROLLER_EXT_SSL_PORT=443
165 TESTS_DIR="tests"
166
167 CLUSTER=""
168 DOMAIN=""
169
170 # Hostnames/IPs used for single-host deploys
171 HOSTNAME_EXT=""
172 IP_INT="127.0.1.1"
173
174 # Initial user setup
175 INITIAL_USER=""
176 INITIAL_USER_EMAIL=""
177 INITIAL_USER_PASSWORD=""
178
179 CONTROLLER_EXT_SSL_PORT=8000
180 KEEP_EXT_SSL_PORT=25101
181 # Both for collections and downloads
182 KEEPWEB_EXT_SSL_PORT=9002
183 WEBSHELL_EXT_SSL_PORT=4202
184 WEBSOCKET_EXT_SSL_PORT=8002
185 WORKBENCH1_EXT_SSL_PORT=443
186 WORKBENCH2_EXT_SSL_PORT=3001
187
188 SSL_MODE="self-signed"
189 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/certs"
190
191 ## These are ARVADOS-related parameters
192 # For a stable release, change RELEASE "production" and VERSION to the
193 # package version (including the iteration, e.g. X.Y.Z-1) of the
194 # release.
195 # The "local.params.example.*" files already set "RELEASE=production"
196 # to deploy  production-ready packages
197 RELEASE="development"
198 VERSION="latest"
199
200 # These are arvados-formula-related parameters
201 # An arvados-formula tag. For a stable release, this should be a
202 # branch name (e.g. X.Y-dev) or tag for the release.
203 # ARVADOS_TAG="2.2.0"
204 # BRANCH="main"
205
206 # Other formula versions we depend on
207 POSTGRES_TAG="v0.43.0"
208 NGINX_TAG="temp-fix-missing-statements-in-pillar"
209 DOCKER_TAG="v2.0.7"
210 LOCALE_TAG="v0.3.4"
211 LETSENCRYPT_TAG="v2.1.0"
212
213 # Salt's dir
214 DUMP_SALT_CONFIG_DIR=""
215 ## states
216 S_DIR="/srv/salt"
217 ## formulas
218 F_DIR="/srv/formulas"
219 ## pillars
220 P_DIR="/srv/pillars"
221 ## tests
222 T_DIR="/tmp/cluster_tests"
223
224 arguments ${@}
225
226 if [ -s ${CONFIG_FILE} ]; then
227   source ${CONFIG_FILE}
228 else
229   echo >&2 "You don't seem to have a config file with initial values."
230   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
231   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
232   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
233   exit 1
234 fi
235
236 if [ ! -d ${CONFIG_DIR} ]; then
237   echo >&2 "You don't seem to have a config directory with pillars and states."
238   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
239   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
240   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
241   exit 1
242 fi
243
244 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
245   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
246   echo >&2 "Please, fix them and re-run the provision script."
247   exit 1
248 fi
249
250 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
251   echo >&2 "ERROR: <CLUSTER> must be exactly 5 alphanumeric characters long"
252   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
253   exit 1
254 fi
255
256 # Only used in single_host/single_name deploys
257 if [ "x${HOSTNAME_EXT}" = "x" ] ; then
258   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
259 fi
260
261 if [ "${DUMP_CONFIG}" = "yes" ]; then
262   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
263 else
264   # Install a few dependency packages
265   # First, let's figure out the OS we're working on
266   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
267   echo "Detected distro: ${OS_ID}"
268
269   case ${OS_ID} in
270     "centos")
271       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
272       sed -i 's/SELINUX=enforcing/SELINUX=permissive' /etc/sysconfig/selinux
273       setenforce permissive
274       yum install -y  curl git jq
275       ;;
276     "debian"|"ubuntu")
277       DEBIAN_FRONTEND=noninteractive apt update
278       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
279       ;;
280   esac
281
282   if which salt-call; then
283     echo "Salt already installed"
284   else
285     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
286     sh /tmp/bootstrap_salt.sh -XdfP -x python3
287     /bin/systemctl stop salt-minion.service
288     /bin/systemctl disable salt-minion.service
289   fi
290
291   # Set salt to masterless mode
292   cat > /etc/salt/minion << EOFSM
293 failhard: "True"
294
295 file_client: local
296 file_roots:
297   base:
298     - ${S_DIR}
299     - ${F_DIR}/*
300
301 pillar_roots:
302   base:
303     - ${P_DIR}
304 EOFSM
305 fi
306
307 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
308
309 # Get the formula and dependencies
310 cd ${F_DIR} || exit 1
311 echo "Cloning formulas"
312 rm -rf ${F_DIR}/* || exit 1
313 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
314 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
315
316 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
317 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
318
319 git clone --quiet https://github.com/netmanagers/nginx-formula.git ${F_DIR}/nginx
320 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
321
322 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
323 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
324
325 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
326 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
327
328 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
329
330 # If we want to try a specific branch of the formula
331 if [ "x${BRANCH}" != "x" ]; then
332   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
333 elif [ "x${ARVADOS_TAG}" != "x" ]; then
334 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
335 fi
336
337 if [ "x${VAGRANT}" = "xyes" ]; then
338   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
339   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
340   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
341 else
342   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
343   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
344   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
345 fi
346
347 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
348
349 echo "Writing pillars and states"
350
351 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
352 # to ease deployment for newcomers
353 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
354   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
355   exit 1
356 fi
357 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
358   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
359        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
360        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
361        s#__CLUSTER__#${CLUSTER}#g;
362        s#__DOMAIN__#${DOMAIN}#g;
363        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
364        s#__IP_INT__#${IP_INT}#g;
365        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
366        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
367        s#__INITIAL_USER__#${INITIAL_USER}#g;
368        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
369        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
370        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
371        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
372        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
373        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
374        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
375        s#__RELEASE__#${RELEASE}#g;
376        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
377        s#__VERSION__#${VERSION}#g;
378        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
379        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
380        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
381        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
382        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
383        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
384        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
385        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
386        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
387        s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
388        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
389        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
390        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
391        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
392        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
393        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
394        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
395   "${f}" > "${P_DIR}"/$(basename "${f}")
396 done
397
398 if [ "x${TEST}" = "xyes" ] && [ ! -d "${SOURCE_TESTS_DIR}" ]; then
399   echo "You requested to run tests, but ${SOURCE_TESTS_DIR} does not exist or is not a directory. Exiting."
400   exit 1
401 fi
402 mkdir -p ${T_DIR}
403 # Replace cluster and domain name in the test files
404 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
405   sed "s#__CLUSTER__#${CLUSTER}#g;
406        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
407        s#__DOMAIN__#${DOMAIN}#g;
408        s#__IP_INT__#${IP_INT}#g;
409        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
410        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
411        s#__INITIAL_USER__#${INITIAL_USER}#g;
412        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
413        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g" \
414   "${f}" > ${T_DIR}/$(basename "${f}")
415 done
416 chmod 755 ${T_DIR}/run-test.sh
417
418 # Replace helper state files that differ from the formula's examples
419 if [ -d "${SOURCE_STATES_DIR}" ]; then
420   mkdir -p "${F_DIR}"/extra/extra
421
422   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
423     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
424          s#__CLUSTER__#${CLUSTER}#g;
425          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
426          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
427          s#__DOMAIN__#${DOMAIN}#g;
428          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
429          s#__IP_INT__#${IP_INT}#g;
430          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
431          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
432          s#__INITIAL_USER__#${INITIAL_USER}#g;
433          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
434          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
435          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
436          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
437          s#__RELEASE__#${RELEASE}#g;
438          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
439          s#__VERSION__#${VERSION}#g;
440          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
441          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
442          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
443          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
444          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
445          s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
446          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
447          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
448          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
449          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
450          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
451          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
452          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
453          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
454          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
455          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
456     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
457   done
458 fi
459
460 # Now, we build the SALT states/pillars trees
461 # As we need to separate both states and pillars in case we want specific
462 # roles, we iterate on both at the same time
463
464 # States
465 cat > ${S_DIR}/top.sls << EOFTSLS
466 base:
467   '*':
468     - locale
469 EOFTSLS
470
471 # Pillars
472 cat > ${P_DIR}/top.sls << EOFPSLS
473 base:
474   '*':
475     - locale
476     - arvados
477 EOFPSLS
478
479 # States, extra states
480 if [ -d "${F_DIR}"/extra/extra ]; then
481   SKIP_SNAKE_OIL="snakeoil_certs"
482   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
483     # In dev mode, we create some snake oil certs that we'll
484     # use as CUSTOM_CERTS, so we don't skip the states file.
485     # Same when using self-signed certificates.
486     SKIP_SNAKE_OIL="dont_snakeoil_certs"
487   fi
488   for f in $(ls "${F_DIR}"/extra/extra/*.sls | grep -v ${SKIP_SNAKE_OIL}); do
489   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
490   done
491   # Use byo or self-signed certificates
492   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
493     mkdir -p "${F_DIR}"/extra/extra/files
494   fi
495 fi
496
497 # If we want specific roles for a node, just add the desired states
498 # and its dependencies
499 if [ -z "${ROLES}" ]; then
500   # States
501   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
502   # Currently, only available on config_examples/multi_host/aws
503   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
504     if [ "${USE_LETSENCRYPT_IAM_USER}" != "yes" ]; then
505       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
506     fi
507     grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
508   else
509     # Use custom certs
510     # Copy certs to formula extra/files
511     # In dev mode, the files will be created and put in the destination directory by the
512     # snakeoil_certs.sls state file
513     mkdir -p /srv/salt/certs
514     cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
515     # We add the custom_certs state
516     grep -q "custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
517   fi
518
519   echo "    - postgres" >> ${S_DIR}/top.sls
520   echo "    - docker.software" >> ${S_DIR}/top.sls
521   echo "    - arvados" >> ${S_DIR}/top.sls
522   echo "    - extra.dns" >> ${S_DIR}/top.sls
523
524   # Pillars
525   echo "    - docker" >> ${P_DIR}/top.sls
526   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
527   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
528   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
529   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
530   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
531   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
532   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
533   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
534   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
535   echo "    - postgresql" >> ${P_DIR}/top.sls
536
537   # Currently, only available on config_examples/multi_host/aws
538   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
539     if [ "${USE_LETSENCRYPT_IAM_USER}" != "yes" ]; then
540       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
541     fi
542     grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
543
544     # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
545     for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
546       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${c}.${CLUSTER}.${DOMAIN}*/g;
547               s#__CERT_PEM__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
548               s#__CERT_KEY__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
549       ${P_DIR}/nginx_${c}_configuration.sls
550     done
551   elif [ "${SSL_MODE}" = "bring-your-own" ]; then
552     # Use custom "bring-your-own" certs (either dev mode or prod)
553     grep -q "custom_certs"       ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
554     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
555     # And add the certs in the custom_certs pillar
556     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
557     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
558
559     for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
560       copy_custom_cert ${CUSTOM_CERTS_DIR} $c
561       grep -q ${c} ${P_DIR}/extra_custom_certs.sls || echo "  - ${c}" >> ${P_DIR}/extra_custom_certs.sls
562
563       # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
564       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${c}.pem/g;
565               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${c}.pem#g;
566               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${c}.key#g" \
567       ${P_DIR}/nginx_${c}_configuration.sls
568     done
569   fi
570 else
571   # If we add individual roles, make sure we add the repo first
572   echo "    - arvados.repo" >> ${S_DIR}/top.sls
573   # We add the extra_custom_certs state
574   grep -q "extra_custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
575
576   # And we add the basic part for the certs pillar
577   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
578     # And add the certs in the custom_certs pillar
579     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
580     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
581     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
582   fi
583
584   for R in ${ROLES}; do
585     case "${R}" in
586       "database")
587         # States
588         echo "    - postgres" >> ${S_DIR}/top.sls
589         # Pillars
590         echo '    - postgresql' >> ${P_DIR}/top.sls
591       ;;
592       "api")
593         # States
594         # FIXME: https://dev.arvados.org/issues/17352
595         grep -q "postgres.client" ${S_DIR}/top.sls || echo "    - postgres.client" >> ${S_DIR}/top.sls
596         grep -q "nginx.passenger" ${S_DIR}/top.sls || echo "    - nginx.passenger" >> ${S_DIR}/top.sls
597         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
598         ### after it. So we add this here as we are, after all, sharing the host for api and controller
599         # Currently, only available on config_examples/multi_host/aws
600         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
601           if [ "${USE_LETSENCRYPT_IAM_USER}" != "yes" ]; then
602             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
603           fi
604           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
605         else
606           # Use custom certs
607           copy_custom_cert ${CUSTOM_CERTS_DIR} controller
608           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
609         fi
610         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
611         # Pillars
612         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
613         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
614         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
615         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
616       ;;
617       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
618         # States
619         grep -q "nginx.passenger" ${S_DIR}/top.sls || echo "    - nginx.passenger" >> ${S_DIR}/top.sls
620         # Currently, only available on config_examples/multi_host/aws
621         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
622           if [ "x${USE_LETSENCRYPT_IAM_USER}" != "xyes" ]; then
623             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
624           fi
625           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
626         else
627           # Use custom certs, special case for keepweb
628           if [ ${R} = "keepweb" ]; then
629             copy_custom_cert ${CUSTOM_CERTS_DIR} download
630             copy_custom_cert ${CUSTOM_CERTS_DIR} collections
631           else
632             copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
633           fi
634         fi
635         # webshell role is just a nginx vhost, so it has no state
636         if [ "${R}" != "webshell" ]; then
637           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
638         fi
639         # Pillars
640         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
641         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
642         # Special case for keepweb
643         if [ ${R} = "keepweb" ]; then
644           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
645           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
646         fi
647
648         # Currently, only available on config_examples/multi_host/aws
649         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
650           if [ "${USE_LETSENCRYPT_IAM_USER}" != "yes" ]; then
651             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
652           fi
653           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
654           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
655
656           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
657           # Special case for keepweb
658           if [ ${R} = "keepweb" ]; then
659             for kwsub in download collections; do
660               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
661                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
662                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
663               ${P_DIR}/nginx_${kwsub}_configuration.sls
664             done
665           else
666             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
667                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
668                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
669             ${P_DIR}/nginx_${R}_configuration.sls
670           fi
671         else
672           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
673           # Special case for keepweb
674           if [ ${R} = "keepweb" ]; then
675             for kwsub in download collections; do
676               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
677                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
678                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
679               ${P_DIR}/nginx_${kwsub}_configuration.sls
680               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
681             done
682           else
683             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
684                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
685                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
686             ${P_DIR}/nginx_${R}_configuration.sls
687             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
688           fi
689         fi
690       ;;
691       "shell")
692         # States
693         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
694         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
695         # Pillars
696         grep -q "docker" ${P_DIR}/top.sls       || echo "    - docker" >> ${P_DIR}/top.sls
697       ;;
698       "dispatcher")
699         # States
700         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
701         # Pillars
702         # ATM, no specific pillar needed
703       ;;
704       "keepstore")
705         # States
706         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
707         # Pillars
708         # ATM, no specific pillar needed
709       ;;
710       *)
711         echo "Unknown role ${R}"
712         exit 1
713       ;;
714     esac
715   done
716 fi
717
718 if [ "${DUMP_CONFIG}" = "yes" ]; then
719   # We won't run the rest of the script because we're just dumping the config
720   exit 0
721 fi
722
723 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
724 if [ -e /root/.psqlrc ]; then
725   if ! ( grep 'pset pager off' /root/.psqlrc ); then
726     RESTORE_PSQL="yes"
727     cp /root/.psqlrc /root/.psqlrc.provision.backup
728   fi
729 else
730   DELETE_PSQL="yes"
731 fi
732
733 echo '\pset pager off' >> /root/.psqlrc
734 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
735
736 # Now run the install
737 salt-call --local state.apply -l ${LOG_LEVEL}
738
739 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
740 if [ "x${DELETE_PSQL}" = "xyes" ]; then
741   echo "Removing .psql file"
742   rm /root/.psqlrc
743 fi
744
745 if [ "x${RESTORE_PSQL}" = "xyes" ]; then
746   echo "Restoring .psql file"
747   mv -v /root/.psqlrc.provision.backup /root/.psqlrc
748 fi
749 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
750
751 # Leave a copy of the Arvados CA so the user can copy it where it's required
752 if [ "$DEV_MODE" = "yes" ]; then
753   echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
754   # If running in a vagrant VM, also add default user to docker group
755   if [ "x${VAGRANT}" = "xyes" ]; then
756     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
757
758     echo "Adding the vagrant user to the docker group"
759     usermod -a -G docker vagrant
760   else
761     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
762   fi
763 fi
764
765 # Test that the installation finished correctly
766 if [ "x${TEST}" = "xyes" ]; then
767   cd ${T_DIR}
768   # If we use RVM, we need to run this with it, or most ruby commands will fail
769   RVM_EXEC=""
770   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
771     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
772   fi
773   ${RVM_EXEC} ./run-test.sh
774 fi